/////////////////// Includes ////////////////////////////////////////////

#include "stdafx.h"
#include "RedRat.h"
#include "RedRatPort.h"
#include "RedRatConnection.h"


//////////////////// Macros / Defines ///////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


////////////////// Implementation //////////////////////////////////////

CRedRatPort::CRedRatPort()
{
}

STDMETHODIMP CRedRatPort::CreateConnection(long Port, VARIANT_BOOL MakeNewSharable, IRedRatConnection** ppConnection)
{
  //Validate our parameters
  if (ppConnection == NULL)
    return E_POINTER;

  //Create a COM CRedRatConnection object using an ATL creator
  CComObject<CRedRatConnection>* pConnection = NULL;
  HRESULT hr = CComObject<CRedRatConnection>::CreateInstance(&pConnection);
  if (SUCCEEDED(hr))
  {
    //Open up the connection
    hr = pConnection->Open(Port);
    if (FAILED(hr))
      return hr;

    //Query for the specific early bound interface which we want to hand back
    hr = pConnection->QueryInterface(IID_IRedRatConnection, reinterpret_cast<void**>(ppConnection));

    //add to module array of shared instances
    if (SUCCEEDED(hr) && (MakeNewSharable == VARIANT_TRUE))
    {
      //Synchronize access to the connections array
      CMyApp* pApp = GetApp();
      CComCritSecLock<CComAutoCriticalSection> lock(pApp->m_csConnections);
      pApp->m_Connections.Add(pConnection);
    }
  }

	return hr;
}
